<?php
	if (!defined('PLX_ROOT')) exit;
	/**
		* Plugin 			MyDataManager
		* @author 			Kamea
	**/
		# Si le formulaire est soumis en POST
		if (!empty($_POST)) {
			plxToken::validateFormToken($_POST);			
			$plxPlugin->setParam('formatDate', $_POST['formatDate'], 'string');			
			$plxPlugin->setParam('date_1', $_POST['date_1'], 'string');
			$plxPlugin->setParam('date_2', $_POST['date_2'], 'string');
			$plxPlugin->setParam('date_3', $_POST['date_3'], 'string');
			$plxPlugin->saveParams();
			
			# Redirection après enregistrement
			header('Location: plugin.php?p=' . basename(__DIR__));
			exit;
		}	
		
		# initialisation des paramêtres
		$var['formatDate'] =  $plxPlugin->getParam('formatDate')=='' ? $plxPlugin->formatDate : $plxPlugin->getParam('formatDate');
		$var['date_1'] =  $plxPlugin->getParam('date_1')=='' ? '' : $plxPlugin->getParam('date_1');
		$var['date_2'] =  $plxPlugin->getParam('date_2')=='' ? '' : $plxPlugin->getParam('date_2');
		$var['date_3'] =  $plxPlugin->getParam('date_3')=='' ? '' : $plxPlugin->getParam('date_3');
?>
<form class="inline-form" action="plugin.php?p=<?= basename(__DIR__) ?>" method="post" >

	<div>
		&nbsp;&nbsp;&nbsp;&nbsp;<label for="id_formatDate"><?php $plxPlugin->lang('L_FORMAT_DATE') ?> :</label>
		<?php plxUtils::printInput('formatDate', $var['formatDate'], 'text', '20-20'); ?> ex: <b id="date"><?= date($var['formatDate']);?></b>
	<details>
		<summary><b style="cursor:pointer;display:inline-block;translate: 0 -2.6rem;font-size:1rem;width:1.4em;aspect-ratio:1;text-align:center;border-radius:50%;box-shadow:inset 0 0 0 1px gray,inset 0 0 0 2vw silver;">?</b></summary>
		<ul style="list-style:none;font-size:1.8rem;">
			<li><b>' j ':</b> Jour du mois sans zéros non significatifs (1 à 31)</li>
			<li><b>' d ':</b> Jour du mois, 2 chiffres avec zéros non significatifs (01 à 31)</li>
			<li><b>' l ':</b> (minuscule « L ») Une représentation textuelle complète du jour de la semaine</li>
			<li><b>' w ':</b> Représentation numérique du jour de la semaine (0=dimanche,1=lundi,...6=samedi)</li>
			<li><b>' D ':</b> Une représentation textuelle d'un jour, trois lettres</li>
			<li><b>' m ':</b> Représentation numérique d'un mois, avec zéros non significatifs (01 à 12)</li>
			<li><b>' n ':</b> Représentation numérique d'un mois, sans zéros non significatifs (1 à 12)</li>
			<li><b>' F ':</b> Une représentation textuelle complète d'un mois, comme janvier ou mars</li>
			<li><b>' M ':</b> Une représentation textuelle courte d'un mois, trois lettres (janv. - déc.)</li>
			<li><b>' Y ':</b> Une représentation numérique complète d'une année, 4 chiffres (1999 OU 2003)</li>
			<li><b>' y ':</b> Une représentation à deux chiffres d'une année (99 OU 03)</li>
			<li><b>' H ':</b> Format 24 heures d'une heure avec zéros non significatifs (00 à 23)</li>
			<li><b>' g ':</b> Format 12 heures d'une heure sans zéros non significatifs (1 à 12)</li>
			<li><b>' h ':</b> Format 12 heures d'une heure avec zéros non significatifs (01 à 12)</li>
			<li><b>' a ':</b> Ante meridiem et Post meridiem en minuscules (am ou pm)</li>
			<li><b>' i ':</b> Minutes avec zéros non significatifs (00 à 59)</li>
			<li><b>' s ':</b> Secondes, avec zéros non significatifs (00 à 59)</li>
			<li><b>' c ':</b> Date ISO 8601 (ex : 2025-11-20T18:05:54.944Z)</li>
		</ul>
		</details>
	</div>
	<p>
		<label for="id_date_1"><?php $plxPlugin->lang('L_TITLE_DATE_1') ?> :</label>
		<?php plxUtils::printInput('date_1', $var['date_1'], 'datetime-local', '20-20'); ?>
	</p>
	<p>
		<label for="id_date_2"><?php $plxPlugin->lang('L_TITLE_DATE_2') ?> ;:</label>
		<?php plxUtils::printInput('date_2', $var['date_2'], 'datetime-local', '20-20'); ?>
	</p>
	<p>
		<label for="id_date_3"><?php $plxPlugin->lang('L_TITLE_DATE_3') ?> :</label>
		<?php plxUtils::printInput('date_3', $var['date_3'], 'datetime-local', '20-20'); ?>
	</p>
	<p class="in-action-bar">
		<?php echo plxToken::getTokenPostMethod(); ?>
		<input type="submit" name="submit" value="Valider" />
	</p>
</form>
<script>
	const frmtDate= document.querySelector('#id_formatDate');
	const shwDate= document.querySelector('#date');
	frmtDate.addEventListener('keyup',function(){
	shwDate.textContent=dateFormat(this.value)
	});
// source function https://gist.github.com/micah1701/4120120
/* Return a formatted string from a date Object mimicking PHP's date() functionality
 *
 * format  string  "Y-m-d H:i:s" or similar PHP-style date format string
 * date    mixed   Date Object, Datestring, or milliseconds
 *
 * NOTE
 * ~~~~~~~~~
 *     PHP: $today =       date('\i\t \i\s \t\h\e jS \d\a\y.');             // it is the 10th day.
 *      JS: today  = dateFormat('\\i\\t \\i\\s \\t\\h\\e jS \\d\\a\\y.');   // it is the 10 day.
 */
function dateFormat(format, date)
{
    if (!date || date === "")
        date = new Date();
    else if (typeof(date) !== 'object')
    {
        // attempt to convert string/number to date object
        try
        {
            if (typeof date === 'number')
               date = new Date(date);                    //timestamp
            else
               date = new Date(date.replace(/-/g, "/")); //probably string
        }
        catch (e)
        {
            date = new Date();                           //Can't handle whatever it was...
        }
    }

    var string = '',
        mo = date.getMonth(),   // month (0-11)
        m1 = mo+1,			    // month (1-12)
        dow = date.getDay(),    // day of week (0-6)
        d = date.getDate(),     // day of the month (1-31)
        y = date.getFullYear(), // 1999 or 2003
        h = date.getHours(),    // hour (0-23)
        mi = date.getMinutes(), // minute (0-59)
        s = date.getSeconds();  // seconds (0-59)

    for (var i = 0, len = format.length; i < len; i++) {
        switch(format[i])
        {
            case '\\': //Handle escaped characters
                i++;
                // console.log(format[i]);
                string+= format[i];
                break;
            case 'j': // Day of the month without leading zeros  (1 to 31)
                string+= d;
                break;

            case 'd': // Day of the month, 2 digits with leading zeros (01 to 31)
                string+= (d < 10) ? "0"+d : d;
                break;

            case 'l': // (lowercase 'L') A full textual representation of the day of the week
                var days = Array("Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday");
                string+= days[dow];
                break;

            case 'w': // Numeric representation of the day of the week (0=Sunday,1=Monday,...6=Saturday)
                string+= dow;
                break;

            case 'D': // A textual representation of a day, three letters
                days = Array("Sun","Mon","Tue","Wed","Thr","Fri","Sat");
                string+= days[dow];
                break;

            case 'm': // Numeric representation of a month, with leading zeros (01 to 12)
                string+= (m1 < 10) ? "0"+m1 : m1;
                break;

            case 'n': // Numeric representation of a month, without leading zeros (1 to 12)
                string+= m1;
                break;

            case 'F': // A full textual representation of a month, such as January or March
                var months = Array("January","February","March","April","May","June","July","August","September","October","November","December");
                string+= months[mo];
                break;

            case 'M': // A short textual representation of a month, three letters (Jan - Dec)
                months = Array("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");
                string+= months[mo];
                break;

            case 'Y': // A full numeric representation of a year, 4 digits (1999 OR 2003)
                string+= y;
                break;

            case 'y': // A two digit representation of a year (99 OR 03)
                string+= y.toString().slice(-2);
                break;

            case 'H': // 24-hour format of an hour with leading zeros (00 to 23)
                string+= (h < 10) ? "0"+h : h;
                break;

            case 'g': // 12-hour format of an hour without leading zeros (1 to 12)
                var hour = (h===0) ? 12 : h;
                string+= (hour > 12) ? hour -12 : hour;
                break;

            case 'h': // 12-hour format of an hour with leading zeros (01 to 12)
                hour = (h===0) ? 12 : h;
                hour = ( hour > 12) ? hour -12 : hour;
                string+= (hour < 10) ? "0"+hour : hour;
                break;

            case 'a': // Lowercase Ante meridiem and Post meridiem (am or pm)
                string+= (h < 12) ? "am" : "pm";
                break;

            case 'i': // Minutes with leading zeros (00 to 59)
                string+= (mi < 10) ? "0"+mi : mi;
                break;

            case 's': // Seconds, with leading zeros (00 to 59)
                string+= (s < 10) ? "0"+s : s;
                break;

            case 'c': // ISO 8601 date (eg: 2012-11-20T18:05:54.944Z)
                string+= date.toISOString();
                break;

            default:
                string+= format[i];
        }
    }

    return string;
}</script>